//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%39AD40C103B5.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%39AD40C103B5.cm

//## begin module%39AD40C103B5.cp preserve=no
//## end module%39AD40C103B5.cp

//## Module: EinsteinBackground%39AD40C103B5; Package specification
//## Subsystem: XSModel::Data::BackCorr%39942CF3002B
//## Source file: /data/verisB/dorman/Xspec/src/XSModel/Data/BackCorr/EinsteinBackground.h

#ifndef EINSTEINBACKGROUND_H
#define EINSTEINBACKGROUND_H 1

//## begin module%39AD40C103B5.additionalIncludes preserve=no
//## end module%39AD40C103B5.additionalIncludes

//## begin module%39AD40C103B5.includes preserve=yes
//## end module%39AD40C103B5.includes

// SpectralData
#include <XSModel/Data/SpectralData.h>
// Background
#include <XSModel/Data/BackCorr/Background.h>
// EinsteinIO
#include <XSModel/DataFactory/EinsteinIO.h>
//## begin module%39AD40C103B5.declarations preserve=no
//## end module%39AD40C103B5.declarations

//## begin module%39AD40C103B5.additionalDeclarations preserve=yes
//## end module%39AD40C103B5.additionalDeclarations


//## begin EinsteinBackCorr%39AD40310256.preface preserve=yes
//## end EinsteinBackCorr%39AD40310256.preface

//## Class: EinsteinBackCorr%39AD40310256
//## Category: XSModel::Data::BackCorr%39942D5A033F
//## Subsystem: XSModel::Data::BackCorr%39942CF3002B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3A281FE102D2;SpectralData { -> }
//## Uses: <unnamed>%3AAD3CE00362;DataSet { -> }

class EinsteinBackCorr : public BackCorr, //## Inherits: <unnamed>%39AD404503B7
                         	public EinsteinIO  //## Inherits: <unnamed>%39AD4074015A
{
  //## begin EinsteinBackCorr%39AD40310256.initialDeclarations preserve=yes
  //## end EinsteinBackCorr%39AD40310256.initialDeclarations

  public:
    //## Constructors (generated)
      EinsteinBackCorr();

      EinsteinBackCorr(const EinsteinBackCorr &right);

    //## Destructor (generated)
      virtual ~EinsteinBackCorr();


    //## Other Operations (specified)
      //## Operation: fileFormat%39AD675D025F
      //	type() returns true if the input filename is of the
      //	format corresponding to the class.
      virtual bool fileFormat (const string& fileName, XspecDataIO::DataType type = XspecDataIO::SpectrumType);

      //## Operation: clone%39DA0C9A02D0
      virtual EinsteinBackCorr* clone () const;

      //## Operation: read%3A2D399A0351
      virtual size_t read (const string& fileName, bool readFlag = true);

      //## Operation: closeSourceFiles%3A3940AC0207
      void closeSourceFiles ();

      //## Operation: initialize%3D3C3606003B
      virtual void initialize (DataSet* parentData, size_t row, const string& fileName, size_t backCorRow);

    // Additional Public Declarations
      //## begin EinsteinBackCorr%39AD40310256.public preserve=yes
      //## end EinsteinBackCorr%39AD40310256.public

  protected:

    //## Other Operations (specified)
      //## Operation: setDescription%3A01E27E0364
      virtual void setDescription (size_t spectrumNumber = 1);

      //## Operation: scaleArrays%3A01E28502B7
      virtual void scaleArrays (bool correction = false);

      //## Operation: setArrays%3A2BC5E000FC
      virtual void setArrays (size_t backgrndRow, bool ignoreStats = false);

      //## Operation: Swap%3A95838102A8
      virtual void Swap (BackCorr& right);

    // Additional Protected Declarations
      //## begin EinsteinBackCorr%39AD40310256.protected preserve=yes
      //## end EinsteinBackCorr%39AD40310256.protected

  private:
    //## Assignment Operation (generated)
      EinsteinBackCorr & operator=(const EinsteinBackCorr &right);


    //## Other Operations (specified)
      //## Operation: copy%3A95838700AC
      virtual void copy (const BackCorr& right);

    // Additional Private Declarations
      //## begin EinsteinBackCorr%39AD40310256.private preserve=yes
      //## end EinsteinBackCorr%39AD40310256.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin EinsteinBackCorr%39AD40310256.implementation preserve=yes
      //## end EinsteinBackCorr%39AD40310256.implementation

};

//## begin EinsteinBackCorr%39AD40310256.postscript preserve=yes
//## end EinsteinBackCorr%39AD40310256.postscript

//## begin EinsteinBackground%39F8584F03E6.preface preserve=yes
//## end EinsteinBackground%39F8584F03E6.preface

//## Class: EinsteinBackground%39F8584F03E6
//## Category: XSModel::Data::BackCorr%39942D5A033F
//## Subsystem: XSModel::Data::BackCorr%39942CF3002B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



typedef EinsteinBackCorr EinsteinBackground;

//## begin EinsteinBackground%39F8584F03E6.postscript preserve=yes
//## end EinsteinBackground%39F8584F03E6.postscript

//## begin EinsteinCorrection%39F8598C02AC.preface preserve=yes
//## end EinsteinCorrection%39F8598C02AC.preface

//## Class: EinsteinCorrection%39F8598C02AC
//## Category: XSModel::Data::BackCorr%39942D5A033F
//## Subsystem: XSModel::Data::BackCorr%39942CF3002B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



typedef EinsteinBackCorr EinsteinCorrection;

//## begin EinsteinCorrection%39F8598C02AC.postscript preserve=yes
//## end EinsteinCorrection%39F8598C02AC.postscript

// Class EinsteinBackCorr 

//## begin module%39AD40C103B5.epilog preserve=yes
//## end module%39AD40C103B5.epilog


#endif
